#include <core/type_util.hpp>
#include <object/Object.h>
#include <ext/typeinfo>

#include <object/ObjectFactory.h>

namespace core {

long unsigned type_util < long unsigned >::denormalize ( long unsigned arg ) {
	return arg;
}

long unsigned type_util < long unsigned >::normalize ( long unsigned arg ) {
	return arg;
}

std::unique_ptr < type_details_base > type_util < long unsigned >::type ( long unsigned ) {
	if constexpr ( std::is_same_v < long unsigned, size_t > ) {
		core::unique_ptr_set < type_details_base > types;
		types.insert ( std::make_unique < type_details_type > ( "long unsigned" ) );
		types.insert ( std::make_unique < type_details_type > ( "size_t" ) );
		return std::make_unique < type_details_variant_type > ( std::move ( types ) );
	} else {
		return std::make_unique < type_details_type > ( "long unsigned" );
	}
}

// ----------------------------------------------------------------------------------------------------------------

unsigned type_util < unsigned >::denormalize ( unsigned arg ) {
	return arg;
}

unsigned type_util < unsigned >::normalize ( unsigned arg ) {
	return arg;
}

std::unique_ptr < type_details_base > type_util < unsigned >::type ( unsigned ) {
	return std::make_unique < type_details_type > ( "unsigned" );
}

// ----------------------------------------------------------------------------------------------------------------

long type_util < long >::denormalize ( long arg ) {
	return arg;
}

long type_util < long >::normalize ( long arg ) {
	return arg;
}

std::unique_ptr < type_details_base > type_util < long >::type ( long ) {
	return std::make_unique < type_details_type > ( "long" );
}

// ----------------------------------------------------------------------------------------------------------------

int type_util < int >::denormalize ( int arg ) {
	return arg;
}

int type_util < int >::normalize ( int arg ) {
	return arg;
}

std::unique_ptr < type_details_base > type_util < int >::type ( int ) {
	return std::make_unique < type_details_type > ( "int" );
}

// ----------------------------------------------------------------------------------------------------------------

char type_util < char >::denormalize ( char arg ) {
	return arg;
}

char type_util < char >::normalize ( char arg ) {
	return arg;
}

std::unique_ptr < type_details_base > type_util < char >::type ( char ) {
	return std::make_unique < type_details_type > ( "char" );
}

// ----------------------------------------------------------------------------------------------------------------

bool type_util < bool >::denormalize ( bool arg ) {
	return arg;
}

bool type_util < bool >::normalize ( bool arg ) {
	return arg;
}

std::unique_ptr < type_details_base > type_util < bool >::type ( bool ) {
	return std::make_unique < type_details_type > ( "bool" );
}

// ----------------------------------------------------------------------------------------------------------------

double type_util < double >::denormalize ( double arg ) {
	return arg;
}

double type_util < double >::normalize ( double arg ) {
	return arg;
}

std::unique_ptr < type_details_base > type_util < double >::type ( double ) {
	return std::make_unique < type_details_type > ( "double" );
}

// ----------------------------------------------------------------------------------------------------------------

std::string type_util < std::string >::denormalize ( std::string arg ) {
	return arg;
}

std::string type_util < std::string >::normalize ( std::string arg ) {
	return arg;
}

std::unique_ptr < type_details_base > type_util < std::string >::type ( std::string ) {
	return std::make_unique < type_details_type > ( "std::string" );
}

// ----------------------------------------------------------------------------------------------------------------

std::unique_ptr < type_details_base > type_util < ext::ostream >::type ( const ext::ostream & ) {
	return std::make_unique < type_details_type > ( "ext::ostream" );
}

} /* namespace core */
